c Program calculates the tidal frequencies that might be found in
c   a time series.
c Code is ripped-off from tidhar (duncan agnew's program)
c
c  JL added the M3 component
      character*4  rnme(27),rname(27)
      dimension tf(27),f(27), nhar(3)
      data rname/'K1  ','O1  ','P1  ','Q1  ','M1  ','J1  ','OO1 ',
     1           'RHO1','SIG1','PI1 ','2Q1 ','PHI1','M2  ','S2  ',
     2           'N2  ','K2  ','NU2 ','MU2 ','L2  ','T2  ','2N2 ',
     3           'EPS2','LDA2','ETA2','M3  ','S1  ','K2X '/
c      data tf/1.0000000,0.9295357,0.9972621,0.8932441,0.9664463,
      data tf/1.0027379,0.9295357,0.9972621,0.8932441,0.9664463,
     1        1.0390296,1.0759401,0.8981010,0.8618093,0.9945243,
     2        0.8569524,1.0082137,1.9322736,2.0000000,1.8959820,
     3        2.0054758,1.9008389,1.8645472,1.9685653,1.9972622,
     4        1.8596903,1.8282556,1.9637084,2.0417675,2.8984107,
     5        1.0000000,2.0054758/
      data rnme/27*'    '/
      print*,' Input the number of days in the time series'
      read(5,*)tlen
c  scan through harmonics (which are listed in order of potential
c  amplitude for each species), eliminating those too close in frequency
c  to one already chosen
c      df = spc/(sam*rnt)
      nhar(1)=12
      nhar(2)=12
      nhar(3)=3
      df=1.0/tlen
      nsd = 0
      ind = 1
      do 11 i = 1,3
      if (i.gt.1) ind = ind + nhar(i-1)
      f(nsd+1) = tf(ind)
      rnme(nsd+1)=rname(ind)
      nh = 1
      do 9 j = 1,nhar(i)-1
      do 7 k = 1,nh
      if(abs(f(nsd+k)-tf(ind+j)).lt.df) go to 9
 7    continue
c  harmonic is acceptable
      f(nsd+nh+1) = tf(ind+j)
      rnme(nsd+nh+1)=rname(ind+j)
      nh = nh + 1
 9    continue
      if(i.eq.1) nsds = nh
      nsd = nsd + nh
 11   continue

      do 15 i=1,nsd
      print*,rnme(i),f(i), 24.0/f(i) 
15    continue
      stop
      end
                                                                                                                            
